
/** ###################################################################
**     THIS BEAN MODULE IS GENERATED BY THE TOOL. DO NOT MODIFY IT.
**     Filename  : AHWTtb.H
**     Project   : PWMPPGTO25
**     Processor : MC9S08QE32CFT
**     Beantype  : AHWT_SPI
**     Version   : Bean 01.011, Driver 01.05, CPU db: 3.00.002
**     Compiler  : CodeWarrior HCS08 C Compiler
**     Date/Time : 08.04.2008, 10:59
**     Abstract  :
**
**     Settings  :
**
**     Contents  :
**         SendByte          - byte AHWTtb_SendByte(byte data);
**         SendCommand       - byte AHWTtb_SendCommand(byte data);
**         InitCommunication - void AHWTtb_InitCommunication(void);
**         ReadData          - byte AHWTtb_ReadData(void);
**         RecvData          - byte AHWTtb_RecvData(void);
**         SendData          - void AHWTtb_SendData(void);
**         SendRespond       - void AHWTtb_SendRespond(byte respond);
**         Wait              - void AHWTtb_Wait(word timeMS);
**         ExecuteCommonCmd  - byte AHWTtb_ExecuteCommonCmd(void);
**         SendAck           - byte AHWTtb_SendAck(void);
**
**     Copyright: Freescale Semiconductor, Inc. All Rights Reserved.
**     Copyright 2016 NXP
**
**     http      : www.freescale.com
**     mail      : info@freescale.com
** ###################################################################*/

#ifndef __AHWTtb
#define __AHWTtb

/* MODULE AHWTtb. */

/* Global definitions */
#define EMPTY_CHAR           0x00

#define ILLEGAL_COMMAND      0xFF
#define COMMAND_ACK          0xFE
#define RETURN_VALUE         0xFD
#define COMMAND_EXECUTED     0xFC
/* Data length does not correspond to given command */
#define ILLEGAL_PARAM_LENGTH 0xFB


#define ERROR_COMMON         0xFF

/* CHARACTERS and COMMANDS */

#define COMMAND_CHAR         0xFF
/* Data characters */
#define DATA_CHAR_0          0x01
#define DATA_CHAR_FF         0x02
/* Received data length is greater than available buffer */
#define ERROR_BUFFER_LENGTH  0x03
/* Received data are OK */
#define ERROR_CRC            0x04
#define INIT_COMMAND         0x05
#define STATUS_COMMAND_TEST_DEV   0x06
#define STATUS_COMMAND_MCU        0x07
#define REPEAT_COMMAND_TEST_DEV   0x08
#define REPEAT_COMMAND_MCU        0x09

/* Definitions of the data buffer */

#define MAX_BUFFER           0xF
#define ID_COMMAND_POS       0x00
#define DATA_LENGTH_POS      0x01
#define DATA_START_POS       0x02

#define RECOVERY_TIME        0x32

/* Internal errors */

#define ERR_INIT_COMMAND    0xF8
#define ERR_COMMAND         0xF7
#define ERR_EMPTY_CHAR      0xF6
#define ERR_NOT_SUPPORTED   0xF5
#define ERR_STATUS_COMMAND_TEST_DEV  0xF4
#define ERR_STATUS_COMMAND_MCU  0xF3
#define ERR_REPEAT_COMMAND_TEST_DEV  0xF2
#define ERR_REPEAT_COMMAND_MCU  0xF1

/* Common command */
#define CMD_READ_MEM         0x01
#define CMD_WRITE_MEM        0x02
#define CMD_STATUS_MCU       0x03
#define CMD_STATUS_TEST_DEV  0x04

/* States of the AHWT module */
/* Idle state after reset of MCU or a command execution */
#define STATE_IDLE               0x00
/* Initialization has been executed as the last command */
#define STATE_INIT               0x01
/* CRC error occured */
#define STATE_ERR_CRC            0x02
/* Illegal command has been received */
#define STATE_ILLEGAL_CMD        0x03
/* Illegal length of a command's parameters */
#define STATE_ILLEGAL_PARAM_LEN  0x04
/* The waiting for a data is performed */
#define STATE_DATA_WAITING       0x05
/* Buffer overflow for sending data - internal error of MCU/Test device project or project design */
#define STATE_BUFFER_OVERFLOW    0x06
/* Undefined control character (0xFF 0xXX) has been received */
#define STATE_UNDEF_CNTR_CHAR    0x07
/* The received command's data length is greater than buffer length */
#define STATE_DATA_LEN_OVERFLOW  0x08
/* Common error occured */
#define STATE_COMMON_ERR         0x09

/* Include shared modules, which are used for whole project */
#include "PE_Types.h"
#include "PE_Error.h"
#include "Cpu.h"



extern byte AHWTtb_DataBuffer[MAX_BUFFER]; /* Internal buffer for data */

/* PE autotest combination */
extern const volatile uint16_t AHWT_TEST_COMBINATION;

void executeTestCmd(void);

#define AHWTtb_RecvByte()
/*
** ===================================================================
**     Method      :  AHWTtb_RecvByte (bean AHWT_SPI)
**
**     Description :
**         This method receives one character or control command through
**         the SPI channel.
**         This method is internal. It is used by Processor Expert only.
** ===================================================================
*/

#define AHWTtb_SendByte(data) ((TPE_ErrCode)AHWTtb_DataBuffer[0])
/*
** ===================================================================
**     Method      :  AHWTtb_SendByte (bean AHWT_SPI)
**
**     Description :
**         This method encodes and sends a byte of data.
**     Parameters  :
**         NAME            - DESCRIPTION
**         data            - Byte of data.
**     Returns     :
**         ---             - Error code - ERR_OK or a error code of
**                           the inherited method SendChar().
** ===================================================================
*/

#define AHWTtb_SendCommand(data) ((TPE_ErrCode)AHWTtb_DataBuffer[0])
/*
** ===================================================================
**     Method      :  AHWTtb_SendCommand (bean AHWT_SPI)
**
**     Description :
**         This method send the specified command, i.e. it send 0xFF
**         prefix and the specified id of the command.
**     Parameters  :
**         NAME            - DESCRIPTION
**         data            - Command identification number.
**     Returns     :
**         ---             - Error code - ERR_OK or a error code of
**                           the inherited method SendChar().
** ===================================================================
*/

#define AHWTtb_InitCommunication()
/*
** ===================================================================
**     Method      :  AHWTtb_InitCommunication (bean AHWT_SPI)
**
**     Description :
**         This method initialize communication. It waits for high
**         level on the MISO input pin and then wait for the
**         specified time.
**     Parameters  : None
**     Returns     : Nothing
** ===================================================================
*/

#define AHWTtb_ReadData() ((TPE_ErrCode)AHWTtb_DataBuffer[0])
/*
** ===================================================================
**     Method      :  AHWTtb_ReadData (bean AHWT_SPI)
**
**     Description :
**         This method received data into DataBuffer, check the CRC
**         and respond to by sending of the command ID.
**     Parameters  : None
**     Returns     :
**         ---             - Error code - ERR_OK - a command has
**                           been successfully received,
**                           ERR_INIT_COMMAND - the init command has
**                           been received, ERR_CRC - the received
**                           and computed CRC is different,
**                           ERR_COMMON - a corrupted or illegal data
**                           has been received.
** ===================================================================
*/

#define AHWTtb_RecvData() ((TPE_ErrCode)AHWTtb_DataBuffer[0])
/*
** ===================================================================
**     Method      :  AHWTtb_RecvData (bean AHWT_SPI)
**
**     Description :
**         This method read data by the ReadData method and performs
**         service of errors state, i.e. if an error is received the
**         corresponding actions are performed othervise (for the
**         non error state) this method is finished for performing
**         of the received command by a user code.
**     Parameters  : None
**     Returns     :
**         ---             - Error code - ERR_OK
** ===================================================================
*/

#define AHWTtb_SendData()
/*
** ===================================================================
**     Method      :  AHWTtb_SendData (bean AHWT_SPI)
**
**     Description :
**         This method computes CRC and sends the data from the
**         DataBuffer.
**     Parameters  : None
**     Returns     : Nothing
** ===================================================================
*/

#define AHWTtb_SendRespond(respond)
/*
** ===================================================================
**     Method      :  AHWTtb_SendRespond (bean AHWT_SPI)
**
**     Description :
**         This methods send a byte of data as a respond for a
**         command. It sets the data length to 1, saves the
**         specified byte into DataBuffer and send the data by
**         calling of the SendData() method.
**     Parameters  :
**         NAME            - DESCRIPTION
**         respond         - Byte of data.
**     Returns     : Nothing
** ===================================================================
*/

#define AHWTtb_Wait(timeMS);
/*
** ===================================================================
**     Method      :  AHWTtb_Wait (bean AHWT_SPI)
**
**     Description :
**         This method wait for specified time in ms.
**     Parameters  :
**         NAME            - DESCRIPTION
**         timeMS          - time in ms
**     Returns     : Nothing
** ===================================================================
*/

#define AHWTtb_ExecuteCommonCmd() ((TPE_ErrCode)AHWTtb_DataBuffer[0])
/*
** ===================================================================
**     Method      :  AHWTtb_ExecuteCommonCmd (bean AHWT_SPI)
**
**     Description :
**         This method execute the common command. It uses the
**         DataBuffer for reading of the data.
**     Parameters  : None
**     Returns     :
**         ---             - Error code. It returns ERR_OK if a
**                           command has been executed and
**                           ERR_NOT_SUPPORTED if the specified
**                           command is not supported.
** ===================================================================
*/

#define AHWTtb_SendAck() AHWTtb_SendByte(AHWTtb_DataBuffer[ID_COMMAND_POS])
/*
** ===================================================================
**     Method      :  AHWTtb_SendAck (bean AHWT_SPI)
**
**     Description :
**         This method send a command acknowledge (command ID) of
**         received command. This method is implemented as a macro
**         that uses the SendByte method.
**     Parameters  : None
**     Returns     :
**         ---             - Error code - ERR_OK or a error code of
**                           the inherited method SendChar().
** ===================================================================
*/

/* END AHWTtb. */

#endif
/* ifndef __AHWTtb */
/*
** ###################################################################
**
**     This file was created by Processor Expert 0.00.00 [04.07]
**     for the Freescale HCS08 series of microcontrollers.
**          !!! DEVELOPER VERSION FOR INTERNAL USAGE ONLY !!!
**
** ###################################################################
*/
